# coding: utf-8

"""
    Messente API

    [Messente](https://messente.com) is a global provider of messaging and user verification services.  * Send and receive SMS, Viber, WhatsApp and Telegram messages. * Manage contacts and groups. * Fetch detailed info about phone numbers. * Blacklist phone numbers to make sure you're not sending any unwanted messages.  Messente builds [tools](https://messente.com/documentation) to help organizations connect their services to people anywhere in the world.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: messente@messente.com
    Generated by: https://openapi-generator.tech
"""


import inspect
import pprint
import re  # noqa: F401
import six

from messente_api.configuration import Configuration


class SyncNumberLookupSuccess(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'request_id': 'str',
        'result': 'list[SyncNumberLookupResult]'
    }

    attribute_map = {
        'request_id': 'request_id',
        'result': 'result'
    }

    def __init__(self, request_id=None, result=None, local_vars_configuration=None):  # noqa: E501
        """SyncNumberLookupSuccess - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._request_id = None
        self._result = None
        self.discriminator = None

        self.request_id = request_id
        self.result = result

    @property
    def request_id(self):
        """Gets the request_id of this SyncNumberLookupSuccess.  # noqa: E501

        ID of the request  # noqa: E501

        :return: The request_id of this SyncNumberLookupSuccess.  # noqa: E501
        :rtype: str
        """
        return self._request_id

    @request_id.setter
    def request_id(self, request_id):
        """Sets the request_id of this SyncNumberLookupSuccess.

        ID of the request  # noqa: E501

        :param request_id: The request_id of this SyncNumberLookupSuccess.  # noqa: E501
        :type request_id: str
        """
        if self.local_vars_configuration.client_side_validation and request_id is None:  # noqa: E501
            raise ValueError("Invalid value for `request_id`, must not be `None`")  # noqa: E501

        self._request_id = request_id

    @property
    def result(self):
        """Gets the result of this SyncNumberLookupSuccess.  # noqa: E501

        A container for phone number info objects  # noqa: E501

        :return: The result of this SyncNumberLookupSuccess.  # noqa: E501
        :rtype: list[SyncNumberLookupResult]
        """
        return self._result

    @result.setter
    def result(self, result):
        """Sets the result of this SyncNumberLookupSuccess.

        A container for phone number info objects  # noqa: E501

        :param result: The result of this SyncNumberLookupSuccess.  # noqa: E501
        :type result: list[SyncNumberLookupResult]
        """
        if self.local_vars_configuration.client_side_validation and result is None:  # noqa: E501
            raise ValueError("Invalid value for `result`, must not be `None`")  # noqa: E501

        self._result = result

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = inspect.getargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SyncNumberLookupSuccess):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SyncNumberLookupSuccess):
            return True

        return self.to_dict() != other.to_dict()
